import numpy as np
import cv2

whole = cv2.imread("../iCub-whole-straight.png",cv2.IMREAD_COLOR)
part = cv2.imread("../iCub-head.png",cv2.IMREAD_COLOR)

whole_gray = cv2.cvtColor(whole,cv2.COLOR_BGR2GRAY)
part_gray = cv2.cvtColor(part,cv2.COLOR_BGR2GRAY)

# phase correlation
src1 = 1.0 - np.float32(whole_gray)/255.0
h1, w1 = whole_gray.shape[:2]
src2 = np.zeros(src1.shape,np.float32)
h2, w2 = part_gray.shape[:2]
src2[:h2,:w2] = 1.0 - np.float32(part_gray)/255.0

ret, confidence = cv2.phaseCorrelate(src1,src2)

x = -int(ret[0])
if x < 0:
    x += w1

y = -int(ret[1])
if y < 0:
    y += h1

# phase correlation result: (x, y, w2, h2), confidence

if confidence > 0.1:
    cv2.rectangle(whole,(x, y, w2, h2),(0,0,255),2)

cv2.imshow("phase correlation", whole)
cv2.waitKey(0)
cv2.destroyAllWindows()
